
/*  xphotohunter v1.4
 *  AUTHOR: Jian-min Chen (ض{)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include "main.h"
#include "handler.h"

/* This is an internally used function to set notebook tab widgets. */
/*
void set_notebook_tab(GtkWidget *notebook, gint page_num, GtkWidget *widget)
{
  GtkNotebookPage *page;
  GtkWidget *notebook_page;

  page = (GtkNotebookPage*) g_list_nth (GTK_NOTEBOOK (notebook)->children, page_num)->data;
  notebook_page = page->child;
  gtk_widget_ref (notebook_page);
  gtk_notebook_remove_page (GTK_NOTEBOOK (notebook), page_num);
  gtk_notebook_insert_page (GTK_NOTEBOOK (notebook), notebook_page, widget, page_num);
  gtk_widget_unref (notebook_page);
}
*/

GtkWidget* create_window1(void)
{
  gchar *title_s[5];
  gchar string[100];

  strcpy(string, TITLE_S);
  strcat(string, VERSION);
  window1 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (window1), "window1", window1);
  gtk_window_set_title (GTK_WINDOW (window1), string);
  gtk_window_set_policy (GTK_WINDOW (window1), TRUE, TRUE, FALSE);

  vpane = gtk_vpaned_new ();
  gtk_widget_show (vpane);
  gtk_container_add (GTK_CONTAINER (window1), vpane);

  fixed1 = gtk_fixed_new ();
  gtk_object_set_data (GTK_OBJECT (window1), "fixed1", fixed1);
  gtk_widget_show (fixed1);
  gtk_paned_add1(GTK_PANED(vpane), fixed1);
  gtk_widget_set_usize (fixed1, 756, 96);

  hbox = gtk_hbox_new (FALSE, 0);
  gtk_paned_add2(GTK_PANED(vpane), hbox);
  gtk_widget_show (hbox);

  hpane = gtk_hpaned_new ();
//  gtk_widget_show (hpane);                                                            // show later
  gtk_box_pack_start (GTK_BOX(hbox), hpane, TRUE, TRUE, 0);

  start_b = gtk_button_new();
  gtk_object_set_data (GTK_OBJECT (window1), "start_b", start_b);
  gtk_widget_show (start_b);
  gtk_fixed_put (GTK_FIXED (fixed1), start_b, 10, 8);
  gtk_widget_set_usize (start_b, 50, 80);

  rank_b = gtk_button_new();
  gtk_object_set_data (GTK_OBJECT (window1), "rank_b", rank_b);
  gtk_widget_show (rank_b);
  gtk_fixed_put (GTK_FIXED (fixed1), rank_b, 65, 8);
  gtk_widget_set_usize (rank_b, 50, 80);

  about_b = gtk_button_new();
  gtk_object_set_data (GTK_OBJECT (window1), "about_b", about_b);
  gtk_widget_show (about_b);
  gtk_fixed_put (GTK_FIXED (fixed1), about_b, 120, 8);
  gtk_widget_set_usize (about_b, 50, 80);

  exit_b = gtk_button_new();
  gtk_object_set_data (GTK_OBJECT (window1), "exit_b", exit_b);
  gtk_widget_show (exit_b);
  gtk_fixed_put (GTK_FIXED (fixed1), exit_b, 175, 8);
  gtk_widget_set_usize (exit_b, 50, 80);

  vseparator1 = gtk_vseparator_new ();
  gtk_object_set_data (GTK_OBJECT (window1), "vseparator1", vseparator1);
  gtk_widget_show (vseparator1);
  gtk_fixed_put (GTK_FIXED (fixed1), vseparator1, 235, 0);
  gtk_widget_set_usize (vseparator1, 5, 96);

  grade_l = gtk_label_new (GRADE_S);
  gtk_object_set_data (GTK_OBJECT (window1), "grade_l", grade_l);
  gtk_widget_show (grade_l);
  gtk_fixed_put (GTK_FIXED (fixed1), grade_l, 245, 16);
  gtk_widget_set_usize (grade_l, 40, 24);
  gtk_label_set_justify (GTK_LABEL (grade_l), GTK_JUSTIFY_LEFT);

  grade_num_t = gtk_entry_new();
  gtk_object_set_data (GTK_OBJECT (window1), "grade_num_t", grade_num_t);
  gtk_widget_show (grade_num_t);
  gtk_fixed_put (GTK_FIXED (fixed1), grade_num_t, 290, 16);
  gtk_widget_set_usize (grade_num_t, 50, 24);
  gtk_entry_set_editable(GTK_ENTRY(grade_num_t), FALSE);

  energy_l = gtk_label_new (ENERGY_S);
  gtk_object_set_data (GTK_OBJECT (window1), "energy_l", energy_l);
  gtk_widget_show (energy_l);
  gtk_fixed_put (GTK_FIXED (fixed1), energy_l, 245, 61);
  gtk_widget_set_usize (energy_l, 40, 24);
  gtk_label_set_justify (GTK_LABEL (energy_l), GTK_JUSTIFY_LEFT);

  progressbar = gtk_progress_bar_new ();
  gtk_object_set_data (GTK_OBJECT (window1), "progressbar", progressbar);
  gtk_widget_show (progressbar);
  gtk_fixed_put (GTK_FIXED (fixed1), progressbar, 290, 53);
  gtk_widget_set_usize (progressbar, 185, 32);
/*
  style = gtk_widget_get_style(progressbar);
  colormap = gdk_window_get_colormap(window1->window);
  if (gdk_color_parse(PROGRESSBAR_COLOR, color)!=0 && gdk_color_alloc(colormap, color)!=0)
  {
     style->fg[0] = *color;
     gtk_widget_set_style(progressbar, style);
  }
*/

  time_l = gtk_label_new (TIME_S);
  gtk_object_set_data (GTK_OBJECT (window1), "time_l", time_l);
  gtk_widget_show (time_l);
  gtk_fixed_put (GTK_FIXED (fixed1), time_l, 350, 16);
  gtk_widget_set_usize (time_l, 65, 24);
  gtk_label_set_justify (GTK_LABEL (time_l), GTK_JUSTIFY_LEFT);

  time_num_t = gtk_entry_new();
  gtk_object_set_data (GTK_OBJECT (window1), "time_num_t", time_num_t);
  gtk_widget_show (time_num_t);
  gtk_fixed_put (GTK_FIXED (fixed1), time_num_t, 425, 16);
  gtk_widget_set_usize (time_num_t, 50, 24);
  gtk_entry_set_editable(GTK_ENTRY(time_num_t), FALSE);

  score_l = gtk_label_new (SCORE_S);
  gtk_object_set_data (GTK_OBJECT (window1), "score_l", score_l);
  gtk_widget_show (score_l);
  gtk_fixed_put (GTK_FIXED (fixed1), score_l, 485, 4);
  gtk_widget_set_usize (score_l, 50, 40);
  gtk_label_set_justify (GTK_LABEL (score_l), GTK_JUSTIFY_LEFT);

  score_num_t = gtk_entry_new();
  gtk_object_set_data (GTK_OBJECT (window1), "score_num_t", score_num_t);
  gtk_widget_show (score_num_t);
  gtk_fixed_put (GTK_FIXED (fixed1), score_num_t, 535, 16);
  gtk_widget_set_usize (score_num_t, 80, 24);
  gtk_entry_set_editable(GTK_ENTRY(score_num_t), FALSE);

  giveup_b = gtk_button_new();
  gtk_object_set_data (GTK_OBJECT (window1), "giveup_b", giveup_b);
  gtk_widget_show (giveup_b);
  gtk_fixed_put (GTK_FIXED (fixed1), giveup_b, 625, 8);
  gtk_widget_set_usize (giveup_b, 95, 50);

  total_l = gtk_label_new (TOTAL_S);
  gtk_widget_show (total_l);
  gtk_fixed_put (GTK_FIXED (fixed1), total_l, 485, 49);
  gtk_widget_set_usize (total_l, 50, 40);
  gtk_label_set_justify (GTK_LABEL (total_l), GTK_JUSTIFY_LEFT);

  total_num_t = gtk_entry_new();
  gtk_widget_show (total_num_t);
  gtk_fixed_put (GTK_FIXED (fixed1), total_num_t, 535, 61);
  gtk_widget_set_usize (total_num_t, 80, 24);
  gtk_entry_set_editable(GTK_ENTRY(total_num_t), FALSE);


//#Playing
  fixed_1 = gtk_fixed_new ();
  gtk_object_set_data (GTK_OBJECT (window1), "fixed_1", fixed_1);
  gtk_widget_show (fixed_1);
  gtk_paned_add1(GTK_PANED(hpane), fixed_1);
  gtk_widget_set_usize (fixed_1, 360, 300);

  fixed_2 = gtk_fixed_new ();
  gtk_object_set_data (GTK_OBJECT (window1), "fixed_2", fixed_2);
  gtk_widget_show (fixed_2);
  gtk_paned_add2(GTK_PANED(hpane), fixed_2);
  gtk_widget_set_usize (fixed_2, 360, 300);

  event_box1 = gtk_event_box_new ();
  gtk_fixed_put (GTK_FIXED (fixed_1), event_box1, 0, 0);
  gtk_widget_show (event_box1);

  event_box2 = gtk_event_box_new ();
  gtk_fixed_put (GTK_FIXED (fixed_2), event_box2, 0, 0);
  gtk_widget_show (event_box2);


//#Nothing & About
  table1 = gtk_table_new(1, 2, FALSE);
  gtk_table_set_row_spacings (GTK_TABLE (table1), 0);
  gtk_table_set_col_spacings (GTK_TABLE (table1), 0);
  gtk_box_pack_start (GTK_BOX(hbox), table1, TRUE, TRUE, 0);
//  gtk_widget_show (table1);                                                           // show later
//  gtk_widget_set_usize (table1, 320, 320);

  frame = gtk_frame_new(NULL);
  gtk_table_attach (GTK_TABLE(table1), frame, 0, 1, 0, 1,
           GTK_FILL|GTK_EXPAND, GTK_FILL|GTK_EXPAND, 3, 3);
  gtk_widget_show(frame);
//  gtk_widget_set_usize (frame, 320, 240);

  about_ok = gtk_button_new_with_label (BUTTON_OK_S);
  gtk_table_attach (GTK_TABLE(table1), about_ok, 0, 1, 1, 2,
           GTK_SHRINK, GTK_SHRINK, 3, 3);
//  gtk_widget_show (about_ok);                                                 // show later
  gtk_widget_set_usize (about_ok, 90, 35);

  table2 = gtk_table_new(2, 1, FALSE);
  gtk_table_set_row_spacings (GTK_TABLE (table2), 0);
  gtk_table_set_col_spacings (GTK_TABLE (table2), 0);
  gtk_box_pack_start (GTK_BOX(hbox), table2, TRUE, TRUE, 0);
//  gtk_widget_show (table2);                                                           // show later
  gtk_widget_set_usize (table2, 300, 300);

  text_w = gtk_text_new(NULL, NULL);
  gtk_widget_show (text_w);
  gtk_widget_set_usize (text_w, 300, 300);
  gtk_table_attach (GTK_TABLE(table2), text_w, 0, 1, 0, 1,
        GTK_FILL|GTK_EXPAND|GTK_SHRINK, GTK_FILL|GTK_EXPAND|GTK_SHRINK, 3, 3);
  gtk_text_set_editable(GTK_TEXT(text_w), FALSE);
  gtk_text_set_word_wrap(GTK_TEXT(text_w), TRUE);
  gtk_widget_realize (text_w);                                          // MUST have the line

  vscroll = gtk_vscrollbar_new (GTK_TEXT(text_w)->vadj);
  gtk_widget_show (vscroll);
  gtk_widget_set_usize (vscroll, 20, 300);
  gtk_table_attach (GTK_TABLE(table2), vscroll, 1, 2, 0, 1,
           GTK_FILL|GTK_SHRINK, GTK_FILL|GTK_EXPAND|GTK_SHRINK, 3, 3);

/*                                                                                      // Now the "text" widget don't
                                                                                        // support horizontal scrollbar.
  hscroll = gtk_hscrollbar_new (GTK_TEXT(text_w)->hadj);
  gtk_widget_show (hscroll);
  gtk_widget_set_usize (hscroll, 300, 20);
  gtk_table_attach (GTK_TABLE(table), hscroll, 0, 1, 1, 2,
           GTK_FILL|GTK_EXPAND|GTK_SHRINK, GTK_FILL|GTK_SHRINK, 3, 3);
*/


//#Rank
  rank_table = gtk_table_new(1, 2, FALSE);
  gtk_table_set_row_spacings (GTK_TABLE (rank_table), 0);
  gtk_table_set_col_spacings (GTK_TABLE (rank_table), 0);
  gtk_box_pack_start (GTK_BOX(hbox), rank_table, TRUE, TRUE, 0);
//  gtk_widget_show (rank_table);                                                               // show later

  title_s[0] = RANK_T;
  title_s[1] = SCORE_T;
  title_s[2] = NAME_T;
  title_s[3] = WORD_T;
  title_s[4] = GRADE_T;
  rank_clist = gtk_clist_new_with_titles(5, title_s);
//  gtk_clist_set_shadow_type(GTK_CLIST(rank_clist), GTK_SHADOW_IN);
  gtk_clist_column_titles_passive(GTK_CLIST(rank_clist));

  gtk_clist_set_column_justification(GTK_CLIST(rank_clist), 0, GTK_JUSTIFY_RIGHT);
  gtk_clist_set_column_justification(GTK_CLIST(rank_clist), 1, GTK_JUSTIFY_RIGHT);
  gtk_clist_set_column_justification(GTK_CLIST(rank_clist), 2, GTK_JUSTIFY_CENTER);
  gtk_clist_set_column_justification(GTK_CLIST(rank_clist), 3, GTK_JUSTIFY_LEFT);
  gtk_clist_set_column_justification(GTK_CLIST(rank_clist), 4, GTK_JUSTIFY_LEFT);

  gtk_clist_set_column_width(GTK_CLIST(rank_clist), 0, 50);
  gtk_clist_set_column_width(GTK_CLIST(rank_clist), 1, 50);
  gtk_clist_set_column_width(GTK_CLIST(rank_clist), 2, 100);
  gtk_clist_set_column_width(GTK_CLIST(rank_clist), 3, 400);
  gtk_clist_set_column_width(GTK_CLIST(rank_clist), 4, 50);

  gtk_table_attach (GTK_TABLE(rank_table), rank_clist, 0, 1, 0, 1,
               GTK_FILL|GTK_EXPAND, GTK_FILL|GTK_EXPAND, 3, 3);
  gtk_widget_show (rank_clist);

  rank_ok = gtk_button_new_with_label(BUTTON_OK_S);
  gtk_table_attach (GTK_TABLE(rank_table), rank_ok, 0, 1, 1, 2,
           GTK_SHRINK, GTK_SHRINK, 3, 3);
  gtk_widget_show (rank_ok);
  gtk_widget_set_usize (rank_ok, 70, 30);

  return window1;
}

void get_data_dir(void)
{
   gchar *env_string;
   DIR* dp;

   env_string = getenv(DIR_ENVIRON);
   if (env_string!=NULL)
      strcpy(data_dir, env_string);
   else
      strcpy(data_dir, DATA_DIR);
   strcat(data_dir, "/");

   dp = opendir(data_dir);                                                       // check whether the dir exists ?
   if (dp==NULL)
   {
      perror("Open dir");
      g_print("%s%s\n", ERROR1_S, data_dir);
      g_print("%s%s\n", ERROR2_S, DIR_ENVIRON);
      g_print("%s\n", ERROR3_S);
      exit(1);
   }
   closedir(dp);
}

void button_box_init(void)
{
   GdkImlibImage *im;
   GdkPixmap *pix;
   GdkBitmap *mask;
   gint width, height;
   gchar string[100];

//#start_b
   start_b_box = gtk_vbox_new (FALSE, 0);
   gtk_container_add (GTK_CONTAINER (start_b), start_b_box);
   gtk_widget_show (start_b_box);

   strcpy(string, data_dir);
   strcat(string, START_B_PIX);
   im = gdk_imlib_load_image(string);
   if (im==NULL)
   {
      perror("Open image file");
      exit(1);
   }
   width = im->rgb_width;
   height = im->rgb_height;
   gdk_imlib_render(im, width, height);
   pix = gdk_imlib_copy_image(im);
   mask = gdk_imlib_copy_mask(im);

   start_b_pixmap = gtk_pixmap_new(pix, mask);
   gtk_widget_show (start_b_pixmap);
   gtk_box_pack_start (GTK_BOX(start_b_box), start_b_pixmap, TRUE, TRUE, 0);

   start_b_label = gtk_label_new(START_S);
   gtk_widget_show (start_b_label);
   gtk_box_pack_start (GTK_BOX(start_b_box), start_b_label, TRUE, TRUE, 0);
   gtk_label_set_justify (GTK_LABEL (start_b_label), GTK_JUSTIFY_LEFT);

   gdk_imlib_destroy_image(im);                                       // to SAVE memory !!
   gdk_imlib_free_pixmap(pix);
   gdk_imlib_free_bitmap(mask);

//#rank_b
   rank_b_box = gtk_vbox_new (FALSE, 0);
   gtk_container_add (GTK_CONTAINER (rank_b), rank_b_box);
   gtk_widget_show (rank_b_box);

   strcpy(string, data_dir);
   strcat(string, RANK_B_PIX);
   im = gdk_imlib_load_image(string);
   if (im==NULL)
   {
      perror("Open image file");
      exit(1);
   }
   width = im->rgb_width;
   height = im->rgb_height;
   gdk_imlib_render(im, width, height);
   pix = gdk_imlib_copy_image(im);
   mask = gdk_imlib_copy_mask(im);

   rank_b_pixmap = gtk_pixmap_new(pix, mask);
   gtk_widget_show (rank_b_pixmap);
   gtk_box_pack_start (GTK_BOX(rank_b_box), rank_b_pixmap, TRUE, TRUE, 0);

   rank_b_label = gtk_label_new(RANK_S);
   gtk_widget_show (rank_b_label);
   gtk_box_pack_start (GTK_BOX(rank_b_box), rank_b_label, TRUE, TRUE, 0);
   gtk_label_set_justify (GTK_LABEL (rank_b_label), GTK_JUSTIFY_LEFT);

   gdk_imlib_destroy_image(im);                                       // to SAVE memory !!
   gdk_imlib_free_pixmap(pix);
   gdk_imlib_free_bitmap(mask);

//#about_b
   about_b_box = gtk_vbox_new (FALSE, 0);
   gtk_container_add (GTK_CONTAINER (about_b), about_b_box);
   gtk_widget_show (about_b_box);

   strcpy(string, data_dir);
   strcat(string, ABOUT_B_PIX);
   im = gdk_imlib_load_image(string);
   if (im==NULL)
   {
      perror("Open image file");
      exit(1);
   }
   width = im->rgb_width;
   height = im->rgb_height;
   gdk_imlib_render(im, width, height);
   pix = gdk_imlib_copy_image(im);
   mask = gdk_imlib_copy_mask(im);

   about_b_pixmap = gtk_pixmap_new(pix, mask);
   gtk_widget_show (about_b_pixmap);
   gtk_box_pack_start (GTK_BOX(about_b_box), about_b_pixmap, TRUE, TRUE, 0);

   about_b_label = gtk_label_new(ABOUT_S);
   gtk_widget_show (about_b_label);
   gtk_box_pack_start (GTK_BOX(about_b_box), about_b_label, TRUE, TRUE, 0);
   gtk_label_set_justify (GTK_LABEL (about_b_label), GTK_JUSTIFY_LEFT);

   gdk_imlib_destroy_image(im);                                       // to SAVE memory !!
   gdk_imlib_free_pixmap(pix);
   gdk_imlib_free_bitmap(mask);

//#exit_b
   exit_b_box = gtk_vbox_new (FALSE, 0);
   gtk_container_add (GTK_CONTAINER (exit_b), exit_b_box);
   gtk_widget_show (exit_b_box);

   strcpy(string, data_dir);
   strcat(string, EXIT_B_PIX);
   im = gdk_imlib_load_image(string);
   if (im==NULL)
   {
      perror("Open image file");
      exit(1);
   }
   width = im->rgb_width;
   height = im->rgb_height;
   gdk_imlib_render(im, width, height);
   pix = gdk_imlib_copy_image(im);
   mask = gdk_imlib_copy_mask(im);

   exit_b_pixmap = gtk_pixmap_new(pix, mask);
   gtk_widget_show (exit_b_pixmap);
   gtk_box_pack_start (GTK_BOX(exit_b_box), exit_b_pixmap, TRUE, TRUE, 0);

   exit_b_label = gtk_label_new(EXIT_S);
   gtk_widget_show (exit_b_label);
   gtk_box_pack_start (GTK_BOX(exit_b_box), exit_b_label, TRUE, TRUE, 0);
   gtk_label_set_justify (GTK_LABEL (exit_b_label), GTK_JUSTIFY_LEFT);

   gdk_imlib_destroy_image(im);                                       // to SAVE memory !!
   gdk_imlib_free_pixmap(pix);
   gdk_imlib_free_bitmap(mask);

//#giveup_b
   giveup_b_box = gtk_hbox_new (FALSE, 0);
   gtk_container_add (GTK_CONTAINER (giveup_b), giveup_b_box);
   gtk_widget_show (giveup_b_box);

   strcpy(string, data_dir);
   strcat(string, GIVEUP_B_PIX);
   im = gdk_imlib_load_image(string);
   if (im==NULL)
   {
      perror("Open image file");
      exit(1);
   }
   width = im->rgb_width;
   height = im->rgb_height;
   gdk_imlib_render(im, width, height);
   pix = gdk_imlib_copy_image(im);
   mask = gdk_imlib_copy_mask(im);

   giveup_b_pixmap = gtk_pixmap_new(pix, mask);
   gtk_widget_show (giveup_b_pixmap);
   gtk_box_pack_start (GTK_BOX(giveup_b_box), giveup_b_pixmap, TRUE, TRUE, 0);

   giveup_b_label = gtk_label_new(GIVEUP_S);
   gtk_widget_show (giveup_b_label);
   gtk_box_pack_start (GTK_BOX(giveup_b_box), giveup_b_label, TRUE, TRUE, 0);
   gtk_label_set_justify (GTK_LABEL (giveup_b_label), GTK_JUSTIFY_LEFT);

   gdk_imlib_destroy_image(im);                                       // to SAVE memory !!
   gdk_imlib_free_pixmap(pix);
   gdk_imlib_free_bitmap(mask);

}

void lamp_init(void)
{
   gint i;
   GdkImlibImage *im;
   gint width, height;
   gchar string[100];

   strcpy(string, data_dir);
   strcat(string, LAMP_FILENAME);
   im = gdk_imlib_load_image(string);
   if (im==NULL)
   {
      perror("Open image file");
      exit(1);
   }

   width = im->rgb_width;
   height = im->rgb_height;
   gdk_imlib_render(im, width, height);
   lamp = gdk_imlib_copy_image(im);                             // "copy", NOT "move"
   lamp_mask = gdk_imlib_copy_mask(im);

   for (i=0;i<DIFF_NUM;i++)
   {
      lamp_p[i] = gtk_pixmap_new(lamp, lamp_mask);
      gtk_fixed_put (GTK_FIXED (fixed1), lamp_p[i], 625+i*(LAMP_SIZE+5), 65);
      gtk_widget_set_usize (lamp_p[i], LAMP_SIZE, LAMP_SIZE);
//      gtk_widget_shape_combine_mask(lamp_p[i], lamp_mask, 0, 0 );
   }

   gdk_imlib_destroy_image(im);                                       // to SAVE memory !!
   gdk_imlib_free_pixmap(lamp);
   gdk_imlib_free_bitmap(lamp_mask);

}

void pixmap_init(void)
{
   GdkImlibImage *im;
   gint width, height;
   gchar string[100];

   strcpy(string, data_dir);
   strcat(string, PRE_PIX_FILE);
   im = gdk_imlib_load_image(string);
   if (im==NULL)
   {
      perror("Open image file");
      exit(1);
   }
   width = im->rgb_width;
   height = im->rgb_height;
   gdk_imlib_render(im, width, height);
   pre_pix = gdk_imlib_copy_image(im);
   pre_pix_mask = gdk_imlib_copy_mask(im);
   pre_pix_w = width;
   pre_pix_h = height;
   gdk_imlib_destroy_image(im);                                       // to SAVE memory !!

   strcpy(string, data_dir);
   strcat(string, ABOUT_PIX_FILE);
   im = gdk_imlib_load_image(string);
   if (im==NULL)
   {
      perror("Open image file");
      exit(1);
   }
   width = im->rgb_width;
   height = im->rgb_height;
   gdk_imlib_render(im, width, height);
   about_pix = gdk_imlib_copy_image(im);
   about_pix_mask = gdk_imlib_copy_mask(im);
   about_pix_w = width;
   about_pix_h = height;
   gdk_imlib_destroy_image(im);                                       // to SAVE memory !!

   pre_p = gtk_pixmap_new(pre_pix, pre_pix_mask);
   gtk_widget_show (pre_p);
   gtk_container_add (GTK_CONTAINER (frame), pre_p);

   pix1 = gdk_pixmap_new(window1->window, 1, 1, style->depth);
   pix1_mask = gdk_pixmap_new(window1->window, 1, 1, 1);
   pix2 = gdk_pixmap_new(window1->window, 1, 1, style->depth);
   pix2_mask = gdk_pixmap_new(window1->window, 1, 1, 1);

   pix_p1 = gtk_pixmap_new(pix1, pix1_mask);
   gtk_widget_show (pix_p1);
   gtk_container_add (GTK_CONTAINER (event_box1), pix_p1);
   pix_p2 = gtk_pixmap_new(pix2, pix2_mask);
   gtk_widget_show (pix_p2);
   gtk_container_add (GTK_CONTAINER (event_box2), pix_p2);

}

void rank_init(void)
{
   gint i, j;
   gchar string[5][100], *string2[5];

   read_rank();

   gtk_clist_freeze(GTK_CLIST(rank_clist));
   for (i=0;i<5;i++)
      string2[i] = string[i];
   for (i=0;i<RANK_NUM;i++)
   {
      if (i<rank_num)
      {
         sprintf(string[0], "%d", rank_record[i].rank);
         sprintf(string[1], "%d", rank_record[i].score);
         strcpy(string[2], rank_record[i].name);
         strcpy(string[3], rank_record[i].word);
         sprintf(string[4], "%d", rank_record[i].grade);         
         gtk_clist_append(GTK_CLIST(rank_clist), string2);              // Strange !!
      }
      else
      {
         for (j=0;j<5;j++)
            strcpy(string[j], "");
         gtk_clist_append(GTK_CLIST(rank_clist), string2);
      }
   }
   gtk_clist_set_row_height(GTK_CLIST(rank_clist), 20);
   gtk_clist_thaw(GTK_CLIST(rank_clist));
}

void read_set_text(gchar *filename)
{
   FILE* fp;
   gchar pathname[100];
   gchar buf[1024];
   gint read_num;
   guint length;

   length = gtk_text_get_length(GTK_TEXT(text_w));
   gtk_text_set_point(GTK_TEXT(text_w), 0);
   gtk_text_forward_delete (GTK_TEXT(text_w), length);

   strcpy(pathname, data_dir);			// read local text file
   strcat(pathname, LOCALE_DIR);
   strcat(pathname, locale_s);
   strcat(pathname, "/"); 
   strcat(pathname, filename);
   fp = fopen(pathname, "r");
   if (fp==NULL)
   {
      strcpy(pathname, data_dir);
      strcat(pathname, filename);
      fp = fopen(pathname, "r");   
   }
      
   if ( fp!=NULL )
   {
      gtk_text_freeze(GTK_TEXT(text_w));

      while (1)
      {
         read_num = fread(buf, 1, 1024, fp);
         if (read_num<=0)
            break;
         gtk_text_insert(GTK_TEXT(text_w), NULL, NULL, NULL, buf, read_num);
      }
      gtk_text_thaw(GTK_TEXT(text_w) );
   }     
}

void show_nothing_widget(void)
{
   read_set_text(RULE_FILE);
   gtk_pixmap_set( GTK_PIXMAP(pre_p), pre_pix, pre_pix_mask);
   gtk_widget_set_usize (pre_p, pre_pix_w, pre_pix_h);

   gtk_widget_hide(hpane);
   gtk_widget_hide(rank_table);
   gtk_widget_hide(about_ok);
   gtk_widget_show(table1);
   gtk_widget_show(table2);
}

void show_playing_widget(void)
{
   gtk_widget_hide(rank_table);
   gtk_widget_hide(table1);
   gtk_widget_hide(table2);
   gtk_widget_hide(about_ok);
   gtk_widget_show(hpane);
}

void show_rank_widget(void)
{
   gtk_widget_hide(hpane);
   gtk_widget_hide(about_ok);
   gtk_widget_hide(table1);
   gtk_widget_hide(table2);
   gtk_widget_show(rank_table);
}

void show_about_widget(void)
{
   read_set_text(LICENSE_FILE);
   gtk_pixmap_set( GTK_PIXMAP(pre_p), about_pix, about_pix_mask);
   gtk_widget_set_usize (pre_p, about_pix_w, about_pix_h);

   gtk_widget_hide(hpane);
   gtk_widget_hide(rank_table);
   gtk_widget_show(about_ok);
   gtk_widget_show(table1);
   gtk_widget_show(table2);
}

void replay_init(void)
{
   show_nothing_widget();

   reset_grade();
   reset_time();
   reset_energy();
   reset_score();

   found = DIFF_NUM;
   reset_lamp();

   rand_seed_init();
   rand_index = -2;
   status = NOTHING;
   pass_num = 0;
}

void reset_grade(void)
{
   grade = 0;
   sprintf(grade_s, "%d", grade);   
   gtk_entry_set_text(GTK_ENTRY(grade_num_t), grade_s);
}

void reset_time(void)
{
   time_total = TIME_AVAIL;
   time_num = TIME_AVAIL;
   sprintf(time_s, "%d", time_num);   
   gtk_entry_set_text(GTK_ENTRY(time_num_t), time_s);
}

void reset_energy(void)
{
   energy = 1;
   gtk_progress_bar_update(GTK_PROGRESS_BAR (progressbar), energy);
}

void reset_score(void)
{
   score = 0;
   sprintf(score_s, "%d", score);      
   gtk_entry_set_text(GTK_ENTRY(score_num_t), score_s);
}

void reset_lamp(void)
{
   int i;
   for (i=0;i<DIFF_NUM;i++)
      gtk_widget_show (lamp_p[i]);
}

void reset_already_right(void)
{
   gint i;
   for (i=0;i<DIFF_NUM;i++)
      already_right[i] = 0;
}

void signal_deal(void)
{
   gtk_signal_connect( GTK_OBJECT(window1), "delete_event",
                                 GTK_SIGNAL_FUNC(main_delete), NULL);
   gtk_signal_connect( GTK_OBJECT(window1), "destroy",
                                 GTK_SIGNAL_FUNC(main_exit), NULL);

   gtk_signal_connect( GTK_OBJECT(start_b), "clicked",
                                 GTK_SIGNAL_FUNC(start_b_clicked), NULL);
   gtk_signal_connect( GTK_OBJECT(rank_b), "clicked",
                                 GTK_SIGNAL_FUNC(rank_b_clicked), NULL);
   gtk_signal_connect( GTK_OBJECT(about_b), "clicked",
                                 GTK_SIGNAL_FUNC(about_b_clicked), NULL);
   gtk_signal_connect( GTK_OBJECT(exit_b), "clicked",
                                 GTK_SIGNAL_FUNC(main_exit), NULL);
   gtk_signal_connect( GTK_OBJECT(giveup_b), "clicked",
                                 GTK_SIGNAL_FUNC(giveup_b_clicked), NULL);
}

gint main_delete(GtkWidget *widget, GdkEvent *event, gpointer data)
{
   return FALSE;
}

void main_exit(GtkWidget *widget, gpointer callback_data)
{
//   calculate_set_rank();
   if ( if_fork==TRUE )
      wait(NULL);
   gtk_main_quit ();
}

void start_b_clicked(GtkWidget *widget, gpointer callback_data)
{
   if (status!=NOTHING)
      return;

   status = PLAYING;
   show_playing_widget();
   next_guess_pixmap();
   playing_signal_generate();
}

void rank_b_clicked(GtkWidget *widget, gpointer callback_data)
{
   if (status!=NOTHING)
      return;
     
   status = RANK;
   show_rank_widget();
   rank_signal_id = gtk_signal_connect( GTK_OBJECT(rank_ok), "button_press_event",
                                                              GTK_SIGNAL_FUNC(rank_ok_clicked), NULL);
}

void about_b_clicked(GtkWidget *widget, gpointer callback_data)
{
   if (status!=NOTHING)
      return;

   status = ABOUT;
   show_about_widget();
   about_signal_id = gtk_signal_connect( GTK_OBJECT(about_ok), "button_press_event",
                                                              GTK_SIGNAL_FUNC(about_ok_clicked), NULL);
}

void giveup_b_clicked(GtkWidget *widget, gpointer callback_data)
{
   if (status!=PLAYING)
      return;

   time_total -= TIME_GIVEUP_LOSS;
   energy -= ENERGY_GIVEUP_LOSS;
   if (energy<0)
   {
      gtk_progress_bar_update(GTK_PROGRESS_BAR (progressbar), 0);
      game_over();
      return;
   }
   else
      gtk_progress_bar_update(GTK_PROGRESS_BAR (progressbar), energy);

   if (grade==rand_len)
      pass_all_with_giveup();
   else
      next_guess_pixmap();
}

void rank_ok_clicked(GtkWidget *widget, gpointer callback_data)
{
   gtk_signal_disconnect( GTK_OBJECT (rank_ok), rank_signal_id);
   status = NOTHING;
   show_nothing_widget();
}

void about_ok_clicked(GtkWidget *widget, gpointer callback_data)
{
   gtk_signal_disconnect( GTK_OBJECT (about_ok), about_signal_id);
   status = NOTHING;
   show_nothing_widget();
}

void playing_signal_generate(void)
{
   point_signal_id1 = gtk_signal_connect( GTK_OBJECT(event_box1), "button_press_event",
                                                              GTK_SIGNAL_FUNC(pixmap_clicked), NULL);
   point_signal_id2 = gtk_signal_connect( GTK_OBJECT(event_box2), "button_press_event",
                                                              GTK_SIGNAL_FUNC(pixmap_clicked), NULL);
   timeout_tag = gtk_timeout_add(CHECK_TIME_INTERVAL, check_time, NULL);
}

void playing_signal_remove(void)
{
   gtk_signal_disconnect(GTK_OBJECT(event_box1), point_signal_id1);
   gtk_signal_disconnect(GTK_OBJECT(event_box2), point_signal_id2);
//   gtk_signal_handlers_destroy( GTK_OBJECT(event_box1) );
//   gtk_signal_handlers_destroy( GTK_OBJECT(event_box2) );   
   gtk_timeout_remove(timeout_tag);
}

void rand_seed_init(void)
{
   time_t time_val;
   time(&time_val);
   srand( (unsigned int) time_val);
}

void get_picture_files(void)
{
   DIR* dp;
   struct dirent* dir;
   gchar filename[3*MAX_PIX][100];
//   gchar pix_filename[MAX_PIX][100];
   gchar string[100], string2[100], sppp[10];
   gint file_num, read_num, length, i, j;
   gboolean if_continue;
   int ret_val;

   strcpy(string, data_dir);
   strcat(string, PICTURE_DIR);
   strcat(string, "/");
   dp = opendir(string);
   for (i=0;i<3*MAX_PIX;i++)
   {
      dir = readdir(dp);
      if (dir==NULL)
         break;
      strcpy(filename[i], dir->d_name);
   }
   read_num = i;
   closedir(dp);

   strcpy(sppp, ".");
   strcat(sppp, DATA_FILE_POST);
   file_num = 0;
   for (i=0;i<read_num;i++)
   {
      length = strlen(filename[i]);
      if ( length<(APPEND_LEN+1) )
         continue;
      substr(filename[i], string, (length-APPEND_LEN-1), (length-1) );
      ret_val = strcmp(string, sppp);
      if (ret_val!=0)
         continue;
      strncpy(string, filename[i], (length-APPEND_LEN-1));
      string[length-APPEND_LEN-1] = '\0';
                                                  // strncpy() don't nessesarily return  NULL-ended string.

      strcpy(string2, string);
      strcat(string2, "a.");
      strcat(string2, PICTURE_FILE_POST);
      if_continue = TRUE;
      for (j=0;j<read_num;j++)
      {
         ret_val = strcmp(filename[j], string2);
         if (ret_val==0)
         {
            if_continue = FALSE;
            break;
         }
      }
      if (if_continue==TRUE)
         continue;

      strcpy(string2, string);
      strcat(string2, "b.");
      strcat(string2, PICTURE_FILE_POST);
      if_continue = TRUE;
      for (j=0;j<read_num;j++)
      {
         ret_val = strcmp(filename[j], string2);
         if (ret_val==0)
         {
            if_continue = FALSE;
            break;
         }
      }
      if (if_continue==TRUE)
         continue;

      file_num++;
//      strcpy(pix_filename[file_num-1], string);
      strcpy(pix_pre_filename[file_num-1], string);
   }

   if (file_num==0)
   {
      g_print(NO_PIC_S);
      exit(1);
   }

   rand_pix = (gint*) malloc( file_num*sizeof(gint) );
//  pix_pre_filename = (gchar**) malloc( file_num*100*sizeof(gchar) );
//   for (i=0;i<file_num;i++)
//      strcpy(pix_pre_filename[i], pix_filename[i]);

   sprintf(total_s, "%d", file_num);   
   gtk_entry_set_text(GTK_ENTRY(total_num_t), total_s);

   rand_len = file_num;
}

void substr(gchar* s1, gchar* s2, gint n1, gint n2)
{
   memcpy(s2, s1+sizeof(gchar)*n1, (n2-n1+1));
   s2[n2-n1+1] = '\0';
}

void next_guess_pixmap(void)
{
   rand_index++;
   if ( rand_index<0 || rand_index>=rand_len )
      rand_dim_generate();
   read_pix();
   read_answer();
   found = 0;
   reset_already_right();
   reset_lamp();
   calculate_set_grade();
   calculate_set_time();
   time(&start_time);
   last_time = start_time + (time_t) (time_total);
}

void rand_dim_generate(void)
{
   gint i, j;
   gboolean if_equal;

   for (i=0;i<rand_len;i++)
   {
      while (1)
      {
         rand_pix[i] = ( (gint) rand() ) % rand_len;
         if_equal = FALSE;
         for (j=0;j<i;j++)
         {
            if ( rand_pix[j]==rand_pix[i] )
            {
               if_equal = TRUE;
               break;
            }
         }
         if ( if_equal==FALSE )
            break;
      }

   }
   rand_index = 0;
}

void read_pix(void)
{
   GdkImlibImage *im;
   gint width, height;
   gchar string[100];

   gdk_imlib_free_pixmap(pix1);                       // to SAVE memory !!
   gdk_imlib_free_bitmap(pix1_mask);

   strcpy(string, data_dir);
   strcat(string, PICTURE_DIR);
   strcat(string, "/");
   strcat(string, pix_pre_filename[rand_pix[rand_index]]);
   strcat(string, "a.");
   strcat(string, PICTURE_FILE_POST);

   im = gdk_imlib_load_image(string);
   if (im==NULL)
   {
      perror("Open image file");
      exit(1);
   }
   width = im->rgb_width;
   height = im->rgb_height;
   gdk_imlib_render(im, width, height);
   pix1 = gdk_imlib_copy_image(im);
   pix1_mask = gdk_imlib_copy_mask(im);

   gtk_pixmap_set( GTK_PIXMAP(pix_p1), pix1, pix1_mask);
   gtk_widget_set_usize (pix_p1, width, height);
   gtk_widget_set_usize (event_box1, width, height);
   pix1_w = width;
   pix1_h = height;

   gdk_imlib_destroy_image(im);           // to SAVE memory !!

   gdk_imlib_free_pixmap(pix2);              // to SAVE memory !!
   gdk_imlib_free_bitmap(pix2_mask);

   strcpy(string, data_dir);
   strcat(string, PICTURE_DIR);
   strcat(string, "/");
   strcat(string, pix_pre_filename[rand_pix[rand_index]]);
   strcat(string, "b.");
   strcat(string, PICTURE_FILE_POST);

   im = gdk_imlib_load_image(string);
   if (im==NULL)
   {
      perror("Open image file");
      exit(1);
   }
   width = im->rgb_width;
   height = im->rgb_height;
   gdk_imlib_render(im, width, height);
   pix2 = gdk_imlib_copy_image(im);
   pix2_mask = gdk_imlib_copy_mask(im);

   gtk_pixmap_set( GTK_PIXMAP(pix_p2), pix2, pix2_mask);
   gtk_widget_set_usize (pix_p2, width, height);
   gtk_widget_set_usize (event_box2, width, height);
   pix2_w = width;
   pix2_h = height;

   gdk_imlib_destroy_image(im);           // to SAVE memory !!

}

void read_answer(void)
{
   FILE* fp;
   gint i, j;
   gchar string[100];

   strcpy(string, data_dir);
   strcat(string, PICTURE_DIR);
   strcat(string, "/");
   strcat(string, pix_pre_filename[rand_pix[rand_index]]);
   strcat(string, ".");
   strcat(string, DATA_FILE_POST);
   fp = fopen(string, "r");

   for (i=0;i<DIFF_NUM;i++)
      for (j=0;j<4;j++)
         fscanf(fp, "%d", &answer[i][j]);
   fclose(fp);
}

void calculate_set_grade(void)
{
   grade++;
   sprintf(grade_s, "%d", grade);      
   gtk_entry_set_text(GTK_ENTRY(grade_num_t), grade_s);
}

void calculate_set_time(void)
{
   sprintf(time_s, "%d", time_total);   
   gtk_entry_set_text(GTK_ENTRY(time_num_t), time_s);
}

void pixmap_clicked(GtkWidget *widget, GdkEvent *event, gpointer data)
{
   gint index, x, y;
   gboolean if_point;

   x = (gint) (event->button.x);
   y = (gint) (event->button.y);

   if_point = FALSE;
   for (index=0;index<DIFF_NUM;index++)
      if ( already_right[index]==0 )
         if ( x>=answer[index][LEFT_INDEX] && x<=answer[index][RIGHT_INDEX] )
            if ( y<=answer[index][DOWN_INDEX] && y>=answer[index][UP_INDEX] )
            {
               if_point = TRUE;
               break;
            }

   if (if_point==TRUE)
      point_right(index);
   else
      point_wrong();
}

void point_right(gint index)
{
   gint i, x, y, w, h;
   gchar string[100];

   already_right[index] = 1;
   found++;
   gtk_widget_hide(lamp_p[DIFF_NUM-found]);
   colormap = gdk_window_get_colormap(window1->window);
   if (gdk_color_parse(ARC_COLOR, &color)!=0 && gdk_color_alloc(colormap, &color)!=0)
      gdk_gc_set_foreground(gc, &color);
   else
      gdk_color_black(colormap, &color);
   gdk_gc_set_foreground(gc, &color);

   x = answer[index][LEFT_INDEX];
   y = answer[index][UP_INDEX];
   w = answer[index][RIGHT_INDEX] - answer[index][LEFT_INDEX];
   h = answer[index][DOWN_INDEX] - answer[index][UP_INDEX];

   for (i=0;i<ARC_WIDTH;i++)
   {
      gdk_draw_arc( (GdkDrawable*)pix1, gc, 0, (x+i), (y+i), (w-2*i), (h-2*i),
                             0*ARC_MULTI, 360*ARC_MULTI);
      gtk_pixmap_set( GTK_PIXMAP(pix_p1), pix1, pix1_mask);
      gtk_widget_set_usize (pix_p1, pix1_w, pix2_h);            // Strange!! Must have the line
                                                                                       // to make drawing appear !

      gdk_draw_arc( (GdkDrawable*)pix2, gc, 0, (x+i), (y+i), (w-2*i), (h-2*i),
                             0*ARC_MULTI, 360*ARC_MULTI);
      gtk_pixmap_set( GTK_PIXMAP(pix_p2), pix2, pix2_mask);
      gtk_widget_set_usize (pix_p2, pix2_w, pix2_h);
   }
   calculate_set_score();

   if (found==DIFF_NUM)
      pass_one();
   else
   {
      strcpy(string, data_dir);
      strcat(string, RIGHT_WAV);
      fork_wavplay(string);
   }
}

void pass_one(void)
{
   gchar string[100];

   pass_num++;
   if (pass_num==rand_len)
      pass_all();
   else if (grade==rand_len)
      pass_all_with_ever_giveup();
   else
   {
      strcpy(string, data_dir);
      strcat(string, RIGHT_WAV);
      fork_wavplay(string);
      dialog_show(PASS_S, pass_after_dialog);
   }
}

void pass_all(void)
{
   gchar string[100];

   strcpy(string, data_dir);
   strcat(string, PASS_ALL_WAV);
   fork_wavplay(string);
   compare_rank();
   dialog_show(PASS_ALL_S, over_after_dialog);
}

void pass_all_with_ever_giveup(void)
{
   gchar string[100];

   strcpy(string, data_dir);
   strcat(string, RIGHT_WAV);
   fork_wavplay(string);
   compare_rank();
   dialog_show(PASS_WRONG_S, over_after_dialog);
}

void pass_all_with_giveup(void)
{
   compare_rank();
   dialog_show(PASS_WRONG_S, over_after_dialog);
}

void point_wrong(void)
{
   gchar string[100];

   energy -= ENERGY_POINT_LOSS;
   if (energy<0)
   {
      gtk_progress_bar_update(GTK_PROGRESS_BAR (progressbar), 0);
      game_over();
      return;
   }
   else
   {
      gtk_progress_bar_update(GTK_PROGRESS_BAR (progressbar), energy);

      strcpy(string, data_dir);
      strcat(string, WRONG_WAV);
      fork_wavplay(string);
   }

}

gint check_time(gpointer data)
{
   time_t now_time;
   gint time_calc, loss_num;

   time(&now_time);
   time_calc = time_total - (gint) (now_time - start_time);
   if (time_calc<0)
   {
      time_calc = (gint) (now_time - last_time);
      loss_num = (time_calc - time_calc%ENERGY_TIME_DELAY) / ENERGY_TIME_DELAY;
      last_time = now_time - (time_t) (time_calc%ENERGY_TIME_DELAY);
      energy -= ENERGY_TIME_LOSS * (loss_num);

      if (energy<0)
      {
         game_over();
         return FALSE;                                          // To end timeout_callback
      }
      else
         gtk_progress_bar_update(GTK_PROGRESS_BAR (progressbar), energy);
   }
   else if ( time_calc!=time_num )
   {
      time_num = time_calc;
      sprintf(time_s, "%d", time_num);         
      gtk_entry_set_text(GTK_ENTRY(time_num_t), time_s);
   }

   return TRUE;
}

void game_over(void)
{
   gchar string[100];

   compare_rank();
   dialog_show(OVER_S, over_after_dialog);

   strcpy(string, data_dir);
   strcat(string, OVER_WAV);
   fork_wavplay(string);
}

void dialog_show(gchar *string, void (*func)(void))
{
   status = DIALOG;

   dialog = gtk_dialog_new();
   gtk_window_set_title (GTK_WINDOW (dialog), TITLE_S);
   gtk_signal_connect( GTK_OBJECT(dialog), "delete_event",
                                 GTK_SIGNAL_FUNC(dialog_delete), func);
   gtk_signal_connect( GTK_OBJECT(dialog), "destroy",
                                 GTK_SIGNAL_FUNC(dialog_destroy), func);

   dialog_message = gtk_label_new (string);                       
   gtk_widget_set_usize (dialog_message, 300, 80);
   gtk_widget_show (dialog_message);
   gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox),
                                  dialog_message, TRUE, TRUE, 0);
   gtk_label_set_justify (GTK_LABEL (grade_l), GTK_JUSTIFY_LEFT);

   dialog_ok = gtk_button_new_with_label (BUTTON_OK_S);
   gtk_widget_show (dialog_ok);
   gtk_widget_set_usize (dialog_ok, 70, 30);
   gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->action_area),
                                  dialog_ok, TRUE, FALSE, 0);                      // TRUE, FALSE
   gtk_signal_connect( GTK_OBJECT(dialog_ok), "clicked",
                                           GTK_SIGNAL_FUNC(dialog_ok_clicked), func);        

   if ( if_rank==TRUE )
   {  
      dialog_separator = gtk_hseparator_new ();
      gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox),
                                     dialog_separator, TRUE, TRUE, 0);
      gtk_widget_show (dialog_separator);                                       
      gtk_widget_set_usize (dialog_separator, 400, 3);

      dialog_table = gtk_table_new(3, 3, FALSE);
      gtk_table_set_row_spacings (GTK_TABLE (dialog_table), 0);
      gtk_table_set_col_spacings (GTK_TABLE (dialog_table), 0);
      gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox),
                                      dialog_table, TRUE, TRUE, 0);
      gtk_widget_show (dialog_table);                                            
      gtk_widget_set_usize (dialog_table, 400, 170);

      dialog_input_l = gtk_label_new (INPUT_S);
      gtk_widget_show (dialog_input_l);
      gtk_table_attach (GTK_TABLE(dialog_table), dialog_input_l, 0, 3, 0, 1,
                                      GTK_FILL|GTK_EXPAND, GTK_FILL|GTK_EXPAND, 3, 3);
      gtk_widget_set_usize (dialog_input_l, 400, 110);

      dialog_name_l = gtk_label_new (NAME_T);
      gtk_widget_show (dialog_name_l);
      gtk_table_attach (GTK_TABLE(dialog_table), dialog_name_l, 0, 1, 1, 2,
                                      GTK_FILL|GTK_EXPAND, GTK_FILL|GTK_EXPAND, 3, 3);
      gtk_widget_set_usize (dialog_name_l, 70, 30);
  
      dialog_word_l = gtk_label_new (WORD_T);
      gtk_widget_show (dialog_word_l);
      gtk_table_attach (GTK_TABLE(dialog_table), dialog_word_l, 0, 1, 2, 3,
                                      GTK_FILL|GTK_EXPAND, GTK_FILL|GTK_EXPAND, 3, 3);
      gtk_widget_set_usize (dialog_input_l, 70, 30);

      dialog_name_t = gtk_entry_new_with_max_length(NAME_LEN-1 );
      gtk_widget_show (dialog_name_t);
      gtk_table_attach (GTK_TABLE(dialog_table), dialog_name_t, 1, 2, 1, 2,
                                      GTK_FILL|GTK_EXPAND, GTK_FILL|GTK_EXPAND, 3, 3);
      gtk_widget_set_usize (dialog_name_t, 100, 30);
      gtk_entry_set_editable(GTK_ENTRY(dialog_name_t), TRUE);
  
      dialog_word_t = gtk_entry_new_with_max_length(WORD_LEN-1);
      gtk_widget_show (dialog_word_t);
      gtk_table_attach (GTK_TABLE(dialog_table), dialog_word_t, 1, 3, 2, 3,
                                      GTK_FILL|GTK_EXPAND, GTK_FILL|GTK_EXPAND, 3, 3);
      gtk_widget_set_usize (dialog_word_t, 330, 30);
      gtk_entry_set_editable(GTK_ENTRY(dialog_word_t), TRUE);
      
      gtk_widget_set_usize (dialog, 400, 290);
   }
   else
      gtk_widget_set_usize (dialog, 300, 110);

   gtk_widget_show(dialog);
   playing_signal_remove();                                      
}

void dialog_delete(GtkWidget *widget, void (*func)(void) )
{
   gtk_widget_hide(dialog);
   if (if_rank==TRUE)
      save_show_rank();
   gtk_widget_destroy(dialog);            // WILL generate "destroy" signal !! 
}

void dialog_destroy(GtkWidget *widget, void (*func)(void) )
{
   (*func)();  
}

void dialog_ok_clicked(GtkWidget *widget, void (*func)(void) )
{
   gtk_widget_hide(dialog);
   if (if_rank==TRUE)
      save_show_rank();
   gtk_widget_destroy(dialog);      	// WILL generate "destroy" signal !! 
}

void pass_after_dialog(void)
{
   status = PLAYING;
   next_guess_pixmap();
   playing_signal_generate();
}

void over_after_dialog(void)
{
   replay_init();
}

void calculate_set_score(void)
{
   score += time_num + 1;
   sprintf(score_s, "%d", score);      
   gtk_entry_set_text(GTK_ENTRY(score_num_t), score_s);
}

void compare_rank(void)
{
   gint i;

   if_rank = FALSE;
   if (rank_num==0)
   {
      if_rank = TRUE;
      insert_num = 1;
      rank_num = 1;
      return;
   }

   for (i=0;i<rank_num;i++)
   {
      if (score>rank_record[i].score)
      {
         if_rank = TRUE;
         insert_num = i+1;
         if (rank_num<RANK_NUM)
            rank_num++;
         return;
      }
   }

   if (rank_num<RANK_NUM)
   {
      if_rank = TRUE;
      insert_num = rank_num +1;
      rank_num++;
      return;
   }
}

void save_show_rank(void)
{
   FILE *fp;
   gint fd, i, j;
   gchar string[100], string2[5][100];
   struct rank_struct rank_temp;

   for (i=rank_num-1;i>=insert_num;i--)
      copy_rank_record(i-1, i);

   rank_record[insert_num-1].rank = insert_num;
   rank_record[insert_num-1].score = score;
   strcpy(rank_record[insert_num-1].name, gtk_entry_get_text(GTK_ENTRY(dialog_name_t)) );
   strcpy(rank_record[insert_num-1].word, gtk_entry_get_text(GTK_ENTRY(dialog_word_t)) );
   rank_record[insert_num-1].grade = grade;

   strcpy(string, data_dir);
   strcat(string, RANK_FILE);
   fp = fopen(string, "w");
   fd = fileno(fp);

   gtk_clist_freeze(GTK_CLIST(rank_clist));
   for (i=0;i<rank_num;i++)
   {
      fwrite(&rank_record[i], 1, sizeof(struct rank_struct), fp);

      sprintf(string2[0], "%d", rank_record[i].rank);
      sprintf(string2[1], "%d", rank_record[i].score);         
      strcpy(string2[2], rank_record[i].name);
      strcpy(string2[3], rank_record[i].word);
      sprintf(string2[4], "%d", rank_record[i].grade);         
      for (j=0;j<5;j++)
         gtk_clist_set_text(GTK_CLIST(rank_clist), i, j, string2[j]);
   }
   rank_temp.rank = 0;
   for (i=rank_num;i<RANK_NUM;i++)
      fwrite(&rank_temp, 1, sizeof(struct rank_struct), fp);

   fchmod(fd, RANK_FILE_MODE);
   fclose(fp);
   gtk_clist_thaw(GTK_CLIST(rank_clist));

   if_rank = FALSE;
}

void copy_rank_record(gint i, gint j)
{
   rank_record[j].rank = j+1;
   rank_record[j].score = rank_record[i].score;
   strcpy(rank_record[j].name, rank_record[i].name);
   strcpy(rank_record[j].word, rank_record[i].word);
   rank_record[j].grade = rank_record[i].grade;
}

void read_rank(void)
{
   FILE* fp;
   gint i;
   gchar string[100];

   strcpy(string, data_dir);
   strcat(string, RANK_FILE);
   fp = fopen(string, "r");
   if (fp==NULL)
   {
      rank_file_init();
      rank_num = 0;
   }
   else
   {
      rank_num = RANK_NUM;
      for (i=0;i<RANK_NUM;i++)
      {
         fread(&rank_record[i], 1, sizeof(struct rank_struct), fp);
         if (rank_record[i].rank==0)
         {
            rank_num = i;
            break;
         }
      }
      fclose(fp);
   }
}

void rank_file_init(void)
{
   FILE* fp;
   gint i;
   gchar string[100];
   gint8 buf[RANK_NUM*sizeof(struct rank_struct)];

   for (i=0;i<RANK_NUM*sizeof(struct rank_struct);i++)
      buf[i] = 0;
   strcpy(string, data_dir);
   strcat(string, RANK_FILE);
   fp = fopen(string, "w");
   fwrite(buf, 1, RANK_NUM*sizeof(struct rank_struct), fp);
   fclose(fp);
}

void fork_wavplay(gchar* wav_file)
{
   pid_t pid;
   char *argv[3];

   if ( if_fork==TRUE )
      wait(NULL);
   if_fork = FALSE;      

   pid = fork();
   if (pid==0)
   {
      argv[0] = ESDPLAY;
      argv[1] = wav_file;
      argv[2] = NULL;
      if ( execvp(ESDPLAY, argv)==-1 )
      {         
         argv[0] = WAVPLAY;      
         if ( execvp(WAVPLAY, argv)==-1 )
         {
            perror(NO_PLAYER_S);
            _exit(-1);					// Don't use exit(-1) !! Because it will close the X-window connection,
                                            // and the original process will get error! 
         }                                   
      }     
      _exit(0);      
   }
   if (pid>0)
      if_fork = TRUE;      
      
}

