
/*  xphotohunter v1.4
 *  AUTHOR: Jian-min Chen (ض{)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

//#include "main.h"

 /*
  * This is an internally used function for setting notebook tabs. It is only
  * included in this header file so you don't get compilation warnings
  */
//void set_notebook_tab(GtkWidget *notebook, gint page_num, GtkWidget *widget);
GtkWidget* create_window1 (void);

void get_data_dir(void);
void button_box_init(void);
void lamp_init(void);
void pixmap_init(void);
void rank_init(void);
void read_set_text(gchar *filename);
void show_nothing_widget(void);
void show_playing_widget(void);
void show_about_widget(void);

void replay_init(void);
void reset_grade(void);
void reset_time(void);
void reset_energy(void);
void reset_score(void);
void reset_lamp(void);
void reset_pixmap(void);
void reset_already_right(void);

void signal_deal(void);
gint main_delete(GtkWidget *widget, GdkEvent *event, gpointer data);
void main_exit(GtkWidget *widget, gpointer callback_data);
void start_b_clicked(GtkWidget *widget, gpointer callback_data);
void rank_b_clicked(GtkWidget *widget, gpointer callback_data);
void about_b_clicked(GtkWidget *widget, gpointer callback_data);
void giveup_b_clicked(GtkWidget *widget, gpointer callback_data);
void playing_signal_generate(void);
void playing_signal_remove(void);
void pixmap_clicked(GtkWidget *widget, GdkEvent *event, gpointer data);
gint check_time(gpointer data);
void dialog_ok_clicked(GtkWidget *widget, void (*func)(void));
void rank_ok_clicked(GtkWidget *widget, gpointer callback_data);
void about_ok_clicked(GtkWidget *widget, gpointer callback_data);

void rand_seed_init(void);
void get_picture_files(void);
void substr(gchar* s1, gchar* s2, gint n1, gint n2);
void next_guess_pixmap(void);
void rand_dim_generate(void);
void read_pix(void);
void read_answer(void);
void calculate_set_grade(void);
void calculate_set_time(void);

void point_right(gint index);
void point_wrong(void);
void pass_one(void);
void pass_all(void);
void pass_all_with_ever_giveup(void);
void pass_all_with_giveup(void);
void game_over(void);
void dialog_show(gchar *string, void (*func)(void));
void dialog_delete(GtkWidget *widget, void (*func)(void) );
void dialog_destroy(GtkWidget *widget, void (*func)(void) );
void dialog_ok_clicked(GtkWidget *widget, void (*func)(void) );
void pass_after_dialog(void);
void over_after_dialog(void);
void fork_wavplay(gchar* wav_file);

void calculate_set_score(void);
void compare_rank(void);
void save_show_rank(void);
void copy_rank_record(gint i, gint j);
void read_rank(void);
void rank_file_init(void);

