
/*  xphotohunter v1.4
 *  AUTHOR: Jian-min Chen (ض{)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include "main.h"
#include "handler.h"

int main (int argc, char *argv[])
{
  gchar string[100];

  get_data_dir();
  												// gtk_set_locale() must be before gtk_init()
  strcpy(locale_s, gtk_set_locale() );		
  textdomain(PACKAGE);
  gtk_init (&argc, &argv);

  strcpy(string, data_dir);
  strcat(string,RC_FILENAME);
  gtk_rc_parse (string);

  gdk_imlib_init();
  window1 = create_window1 ();

//gtk_widget_push_visual(gdk_imlib_get_visual());
//gtk_widget_push_colormap(gdk_imlib_get_colormap());
  style = gtk_widget_get_style(window1);
  gc = gdk_gc_new(window1->window);
  button_box_init();
  lamp_init();
  pixmap_init();
  rank_init();
  get_picture_files();
  if_fork = FALSE;

  replay_init();
  gtk_widget_show (window1);

  signal_deal();
  gtk_main ();
  return 0;
}

